diff --git a/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
similarity index 89%
rename from src/main/java/net/minecraft/server/world/ServerPlayerController.java
rename to game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 12dc99d2d..588a3a41f 100644
--- a/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -3,11 +3,12 @@ package net.minecraft.server.world;
 
 import net.minecraft.core.block.Block;
 
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.BlockUpdatePacket;
+import net.minecraft.core.net.packet.PacketBlockUpdate;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
@@ -30,7 +31,7 @@ public class ServerPlayerController
             int j = thisWorld.getBlockId(destroyX, destroyY, destroyZ);
             if(j != 0)
             {
-                Block block = Block.blocksList[j];
+                Block block = Blocks.blocksList[j];
                 float f = block.blockStrength(thisWorld, destroyX, destroyY, destroyZ, destroySide, player) * (float)(i + 1);
                 if(f >= 1.0F)
                 {
@@ -76,7 +77,7 @@ public class ServerPlayerController
             int i1 = thisWorld.getBlockId(x, y, z);
             if(i1 != 0)
             {
-                Block block = Block.blocksList[i1];
+                Block block = Blocks.blocksList[i1];
                 float f = block.blockStrength(thisWorld, x, y, z, side, player) * (float)(l + 1);
                 if(f >= 0.7F)
                 {
@@ -98,7 +99,7 @@ public class ServerPlayerController
 
     public boolean removeBlock(int x, int y, int z)
     {
-        Block block = Block.blocksList[thisWorld.getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[thisWorld.getBlockId(x, y, z)];
         int l = thisWorld.getBlockMetadata(x, y, z);
         return thisWorld.setBlockWithNotify(x, y, z, 0);
     }
@@ -115,7 +116,7 @@ public class ServerPlayerController
     			return false;
     		}
     	}
-        Block block = Block.getBlock(id);
+        Block block = Blocks.getBlock(id);
         TileEntity tileEntity = thisWorld.getBlockEntity(x, y, z);
         thisWorld.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
         boolean flag = removeBlock(x, y, z);
@@ -124,10 +125,10 @@ public class ServerPlayerController
         		block.onBlockDestroyedByPlayer(thisWorld, x, y, z, side, meta, player, heldItem);
         	}
         }
-        if(flag && player.canHarvestBlock(Block.blocksList[id]) && player.getGamemode().dropBlockOnBreak())
+        if(flag && player.canHarvestBlock(Blocks.blocksList[id]) && player.getGamemode().dropBlockOnBreak())
         {
-            Block.blocksList[id].harvestBlock(thisWorld, player, x, y, z, meta, tileEntity);
-            ((PlayerServer) player).playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, thisWorld));
+            Blocks.blocksList[id].harvestBlock(thisWorld, player, x, y, z, meta, tileEntity);
+            ((PlayerServer) player).playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, thisWorld));
         }
         ItemStack itemstack = player.getCurrentEquippedItem();
         if(itemstack != null)
@@ -173,7 +174,7 @@ public class ServerPlayerController
                 }
             }
             if (!player.isSneaking() || itemstack == null) {  // If standing or hand empty perform block right click method
-                if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+                if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
                     return true;
                 }
             }
@@ -184,7 +185,7 @@ public class ServerPlayerController
             }
         } else {
             if (!player.isSneaking()) {  // If standing or hand empty perform block right click method
-                if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+                if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
                     return true;
                 }
             }
diff --git a/src/main/java/net/minecraft/server/world/WorldManager.java b/game/server/src/main/java/net/minecraft/server/world/WorldManager.java
similarity index 91%
rename from src/main/java/net/minecraft/server/world/WorldManager.java
rename to game/server/src/main/java/net/minecraft/server/world/WorldManager.java
index d4e2549b5..1690a0067 100644
--- a/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -8,8 +8,8 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.net.packet.PlaySoundEffectPacket;
-import net.minecraft.core.net.packet.PlaySoundEffectDirectPacket;
+import net.minecraft.core.net.packet.PacketPlaySoundEffect;
+import net.minecraft.core.net.packet.PacketPlaySoundEffectDirect;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.LevelListener;
@@ -77,7 +77,7 @@ public class WorldManager
 			}
 			return;
 		}
-		PlaySoundEffectDirectPacket packet = new PlaySoundEffectDirectPacket(soundId, soundType, x, y, z, volume, pitch);
+		PacketPlaySoundEffectDirect packet = new PacketPlaySoundEffectDirect(soundId, soundType, x, y, z, volume, pitch);
 		float range = 16.0f;
 		if(volume > 1.0f) {
 			range *= volume;
@@ -119,6 +119,6 @@ public class WorldManager
     @Override
 	public void levelEvent(Player player, int id, int x, int y, int z, int data)
     {
-        mcServer.playerList.sendPacketToOtherPlayersAroundPoint(player, x, y, z, 64D, worldServer.dimension.id, new PlaySoundEffectPacket(id, x, y, z, data));
+        mcServer.playerList.sendPacketToOtherPlayersAroundPoint(player, x, y, z, 64D, worldServer.dimension.id, new PacketPlaySoundEffect(id, x, y, z, data));
     }
 }
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
similarity index 89%
rename from src/main/java/net/minecraft/server/world/WorldServer.java
rename to game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 24b2b389b..719c013b0 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -110,7 +110,7 @@ public class WorldServer extends World
                             }
                         }
                         if(player != null) {
-                            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.ORANGE + " went to sleep. Sweet dreams!"), dimension.id);
+                            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.ORANGE + " went to sleep. Sweet dreams!"), dimension.id);
                         }
                     }
                 }
@@ -138,15 +138,15 @@ public class WorldServer extends World
             if(MinecraftServer.getInstance() != null && player != null && players.size() > 1 && req > 1) {
                 int moreReq = req - playersSleeping;
                 if(player.isPlayerSleeping()) {
-                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " went to bed."), dimension.id);
+                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " went to bed."), dimension.id);
                 }else {
-                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " has left their bed."), dimension.id);
+                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " has left their bed."), dimension.id);
                 }
                 if(moreReq > 0) {
                     if(moreReq > 1) {
-                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.LIGHT_GRAY + "" + moreReq + " more players are required to sleep to skip to daytime"), dimension.id);
+                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.LIGHT_GRAY + "" + moreReq + " more players are required to sleep to skip to daytime"), dimension.id);
                     }else {
-                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.LIGHT_GRAY + "1 more player is required to sleep to skip to daytime"), dimension.id);
+                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.LIGHT_GRAY + "1 more player is required to sleep to skip to daytime"), dimension.id);
                     }
 
                 }
@@ -165,7 +165,7 @@ public class WorldServer extends World
     {
         if(super.addWeatherEffect(entity))
         {
-            mcServer.playerList.sendPacketToPlayersAroundPoint(entity.x, entity.y, entity.z, 512D, dimension.id, new WeatherEffectPacket(entity));
+            mcServer.playerList.sendPacketToPlayersAroundPoint(entity.x, entity.y, entity.z, 512D, dimension.id, new PacketWeatherEffect(entity));
             return true;
         } else
         {
@@ -176,20 +176,20 @@ public class WorldServer extends World
     @Override
     public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus)
     {
-        EnitityEventPacket enitityEventPacket38Entitystatus = new EnitityEventPacket(entityId.id, entityStatus);
+        PacketEntityEvent enitityEventPacket38Entitystatus = new PacketEntityEvent(entityId.id, entityStatus);
         mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entityId, enitityEventPacket38Entitystatus);
     }
 
     @Override
     public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus, float attackedAtYaw)
     {
-        EnitityEventPacket enitityEventPacket38Entitystatus = new EnitityEventPacket(entityId.id, entityStatus, attackedAtYaw);
+        PacketEntityEvent enitityEventPacket38Entitystatus = new PacketEntityEvent(entityId.id, entityStatus, attackedAtYaw);
         mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entityId, enitityEventPacket38Entitystatus);
     }
 
     @Override
     public void sendTrackedEntityDataPacket(Entity entity) {
-        EntityTagDataPacket entitytagdataNBT = new EntityTagDataPacket(entity);
+        PacketEntityTagData entitytagdataNBT = new PacketEntityTagData(entity);
         mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entity, entitytagdataNBT);
     }
 
@@ -208,14 +208,14 @@ public class WorldServer extends World
         explosion.isFlaming = flaming;
         explosion.explode();
         explosion.addEffects(true);
-        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new ExplosionPacket(x, y, z, explosionSize, explosion.destroyedBlockPositions, isCannonBall));
+        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new PacketExplosion(x, y, z, explosionSize, explosion.destroyedBlockPositions, isCannonBall));
         return explosion;
     }
     @Override
     public void triggerEvent(int x, int y, int z, int index, int data)
     {
         super.triggerEvent(x, y, z, index, data);
-        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new BlockEventPacket(x, y, z, index, data));
+        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new PacketBlockEvent(x, y, z, index, data));
     }
 
     public void checkLock()
@@ -228,13 +228,13 @@ public class WorldServer extends World
         super.tick();
 
         if (System.currentTimeMillis() - lastWeatherSend > 1000) {
-            mcServer.playerList.sendPacketToAllPlayers(new WeatherStatusPacket(dimension.id, getCurrentWeather() != null ? getCurrentWeather().weatherId : -1, weatherManager.getNextWeather() != null ? weatherManager.getNextWeather().weatherId : -1, weatherManager.getWeatherDuration(), weatherManager.getWeatherIntensity(), weatherManager.getWeatherPower()));
+            mcServer.playerList.sendPacketToAllPlayers(new PacketWeatherStatus(dimension.id, getCurrentWeather() != null ? getCurrentWeather().weatherId : -1, weatherManager.getNextWeather() != null ? weatherManager.getNextWeather().weatherId : -1, weatherManager.getWeatherDuration(), weatherManager.getWeatherIntensity(), weatherManager.getWeatherPower()));
             lastWeatherSend = System.currentTimeMillis();
         }
     }
     @Override
     public void sendGlobalMessage(String message){
-        mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(message));
+        mcServer.playerList.sendPacketToAllPlayers(new PacketChat(message));
     }
 
     @Override
@@ -245,7 +245,7 @@ public class WorldServer extends World
         byte b3 = (byte) ((rainbowTicks >>  0) & 0xFF);
 //        System.out.printf("b0:%s b1:%s b2:%s b3:%s\n", b0, b1, b2, b3);
 //        System.out.println("Sent rainbow with " + rainbowTicks + " ticks!");
-        mcServer.playerList.sendPacketToAllPlayersInDimension(new CustomPayloadPacket("BTA|RainbowStart", new byte[]{b0, b1, b2, b3}), dimension.id);
+        mcServer.playerList.sendPacketToAllPlayersInDimension(new PacketCustomPayload("BTA|RainbowStart", new byte[]{b0, b1, b2, b3}), dimension.id);
         super.addRainbow(rainbowTicks);
     }
     public ChunkProviderServer chunkProviderServer;
diff --git a/gradle/libs.versions.toml b/gradle/libs.versions.toml
new file mode 100644
index 000000000..c536f6277
--- /dev/null
+++ b/gradle/libs.versions.toml
@@ -0,0 +1,26 @@
+[versions]
+log4j = "2.19.0"
+lwjgl = "3.3.4"
+
+[libraries]
+jetbrains-annotations = { module = "org.jetbrains:annotations", version = "24.0.0" }
+gson = { module = "com.google.code.gson:gson", version = "2.10.1" }
+brigadier = { module = "com.mojang:brigadier", version = "1.0.18" }
+slf4j-api = { module = "org.slf4j:slf4j-api", version = "2.0.7" }
+log4j-core = { module = "org.apache.logging.log4j:log4j-core", version.ref = "log4j" }
+log4j-api = { module = "org.apache.logging.log4j:log4j-api", version.ref = "log4j" }
+log4j-slf4j2 = { module = "org.apache.logging.log4j:log4j-slf4j2-impl", version.ref = "log4j" }
+lwjgl = { module = "org.lwjgl:lwjgl", version.ref = "lwjgl" }
+lwjgl-assimp = { module = "org.lwjgl:lwjgl-assimp", version.ref = "lwjgl" }
+lwjgl-glfw = { module = "org.lwjgl:lwjgl-glfw", version.ref = "lwjgl" }
+lwjgl-openal = { module = "org.lwjgl:lwjgl-openal", version.ref = "lwjgl" }
+lwjgl-opengl = { module = "org.lwjgl:lwjgl-opengl", version.ref = "lwjgl" }
+lwjgl-stb = { module = "org.lwjgl:lwjgl-stb", version.ref = "lwjgl" }
+lwjgl-bom = { module = "org.lwjgl:lwjgl-bom", version.ref = "lwjgl" }
+
+[bundles]
+log4j = ["slf4j-api", "log4j-core", "log4j-api", "log4j-slf4j2"]
+lwjgl = ["lwjgl", "lwjgl-assimp", "lwjgl-glfw", "lwjgl-openal", "lwjgl-opengl", "lwjgl-stb"]
+
+[plugins]
+shadow = { id = "com.gradleup.shadow", version = "8.3.5" }
\ No newline at end of file
diff --git a/gradlew b/gradlew
index 1b6c78733..f5feea6d6 100755
--- a/gradlew
+++ b/gradlew
@@ -15,6 +15,8 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 #
+# SPDX-License-Identifier: Apache-2.0
+#
 
 ##############################################################################
 #
@@ -55,7 +57,7 @@
 #       Darwin, MinGW, and NonStop.
 #
 #   (3) This script is generated from the Groovy template
-#       https://github.com/gradle/gradle/blob/master/subprojects/plugins/src/main/resources/org/gradle/api/internal/plugins/unixStartScript.txt
+#       https://github.com/gradle/gradle/blob/HEAD/platforms/jvm/plugins-application/src/main/resources/org/gradle/api/internal/plugins/unixStartScript.txt
 #       within the Gradle project.
 #
 #       You can find Gradle at https://github.com/gradle/gradle/.
@@ -80,13 +82,12 @@ do
     esac
 done
 
-APP_HOME=$( cd "${APP_HOME:-./}" && pwd -P ) || exit
-
-APP_NAME="Gradle"
+# This is normally unused
+# shellcheck disable=SC2034
 APP_BASE_NAME=${0##*/}
-
-# Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
-DEFAULT_JVM_OPTS='"-Xmx64m" "-Xms64m"'
+# Discard cd standard output in case $CDPATH is set (https://github.com/gradle/gradle/issues/25036)
+APP_HOME=$( cd -P "${APP_HOME:-./}" > /dev/null && printf '%s
+' "$PWD" ) || exit
 
 # Use the maximum available, or set MAX_FD != -1 to use that value.
 MAX_FD=maximum
@@ -133,22 +134,29 @@ location of your Java installation."
     fi
 else
     JAVACMD=java
-    which java >/dev/null 2>&1 || die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
+    if ! command -v java >/dev/null 2>&1
+    then
+        die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
 
 Please set the JAVA_HOME variable in your environment to match the
 location of your Java installation."
+    fi
 fi
 
 # Increase the maximum file descriptors if we can.
 if ! "$cygwin" && ! "$darwin" && ! "$nonstop" ; then
     case $MAX_FD in #(
       max*)
+        # In POSIX sh, ulimit -H is undefined. That's why the result is checked to see if it worked.
+        # shellcheck disable=SC2039,SC3045
         MAX_FD=$( ulimit -H -n ) ||
             warn "Could not query maximum file descriptor limit"
     esac
     case $MAX_FD in  #(
       '' | soft) :;; #(
       *)
+        # In POSIX sh, ulimit -n is undefined. That's why the result is checked to see if it worked.
+        # shellcheck disable=SC2039,SC3045
         ulimit -n "$MAX_FD" ||
             warn "Could not set maximum file descriptor limit to $MAX_FD"
     esac
@@ -193,11 +201,15 @@ if "$cygwin" || "$msys" ; then
     done
 fi
 
-# Collect all arguments for the java command;
-#   * $DEFAULT_JVM_OPTS, $JAVA_OPTS, and $GRADLE_OPTS can contain fragments of
-#     shell script including quotes and variable substitutions, so put them in
-#     double quotes to make sure that they get re-expanded; and
-#   * put everything else in single quotes, so that it's not re-expanded.
+
+# Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
+DEFAULT_JVM_OPTS='"-Xmx64m" "-Xms64m"'
+
+# Collect all arguments for the java command:
+#   * DEFAULT_JVM_OPTS, JAVA_OPTS, JAVA_OPTS, and optsEnvironmentVar are not allowed to contain shell fragments,
+#     and any embedded shellness will be escaped.
+#   * For example: A user cannot expect ${Hostname} to be expanded, as it is an environment variable and will be
+#     treated as '${Hostname}' itself on the command line.
 
 set -- \
         "-Dorg.gradle.appname=$APP_BASE_NAME" \
@@ -205,6 +217,12 @@ set -- \
         org.gradle.wrapper.GradleWrapperMain \
         "$@"
 
+# Stop when "xargs" is not available.
+if ! command -v xargs >/dev/null 2>&1
+then
+    die "xargs is not available"
+fi
+
 # Use "xargs" to parse quoted args.
 #
 # With -n1 it outputs one arg per line, with the quotes and backslashes removed.
diff --git a/gradlew.bat b/gradlew.bat
index 107acd32c..9d21a2183 100644
--- a/gradlew.bat
+++ b/gradlew.bat
@@ -13,8 +13,10 @@
 @rem See the License for the specific language governing permissions and
 @rem limitations under the License.
 @rem
+@rem SPDX-License-Identifier: Apache-2.0
+@rem
 
-@if "%DEBUG%" == "" @echo off
+@if "%DEBUG%"=="" @echo off
 @rem ##########################################################################
 @rem
 @rem  Gradle startup script for Windows
@@ -25,7 +27,8 @@
 if "%OS%"=="Windows_NT" setlocal
 
 set DIRNAME=%~dp0
-if "%DIRNAME%" == "" set DIRNAME=.
+if "%DIRNAME%"=="" set DIRNAME=.
+@rem This is normally unused
 set APP_BASE_NAME=%~n0
 set APP_HOME=%DIRNAME%
 
@@ -40,13 +43,13 @@ if defined JAVA_HOME goto findJavaFromJavaHome
 
 set JAVA_EXE=java.exe
 %JAVA_EXE% -version >NUL 2>&1
-if "%ERRORLEVEL%" == "0" goto execute
+if %ERRORLEVEL% equ 0 goto execute
 
-echo.
-echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
-echo.
-echo Please set the JAVA_HOME variable in your environment to match the
-echo location of your Java installation.
+echo. 1>&2
+echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH. 1>&2
+echo. 1>&2
+echo Please set the JAVA_HOME variable in your environment to match the 1>&2
+echo location of your Java installation. 1>&2
 
 goto fail
 
@@ -56,11 +59,11 @@ set JAVA_EXE=%JAVA_HOME%/bin/java.exe
 
 if exist "%JAVA_EXE%" goto execute
 
-echo.
-echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%
-echo.
-echo Please set the JAVA_HOME variable in your environment to match the
-echo location of your Java installation.
+echo. 1>&2
+echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME% 1>&2
+echo. 1>&2
+echo Please set the JAVA_HOME variable in your environment to match the 1>&2
+echo location of your Java installation. 1>&2
 
 goto fail
 
@@ -75,13 +78,15 @@ set CLASSPATH=%APP_HOME%\gradle\wrapper\gradle-wrapper.jar
 
 :end
 @rem End local scope for the variables with windows NT shell
-if "%ERRORLEVEL%"=="0" goto mainEnd
+if %ERRORLEVEL% equ 0 goto mainEnd
 
 :fail
 rem Set variable GRADLE_EXIT_CONSOLE if you need the _script_ return code instead of
 rem the _cmd.exe /c_ return code!
-if  not "" == "%GRADLE_EXIT_CONSOLE%" exit 1
-exit /b 1
+set EXIT_CODE=%ERRORLEVEL%
+if %EXIT_CODE% equ 0 set EXIT_CODE=1
+if not ""=="%GRADLE_EXIT_CONSOLE%" exit %EXIT_CODE%
+exit /b %EXIT_CODE%
 
 :mainEnd
 if "%OS%"=="Windows_NT" endlocal
diff --git a/settings.gradle.kts b/settings.gradle.kts
index e4a1a40ca..39b025406 100644
--- a/settings.gradle.kts
+++ b/settings.gradle.kts
@@ -1,2 +1,6 @@
 rootProject.name = "better-than-adventure"
-
+include("game:core")
+include("game:client")
+include("game:server")
+include("util:stellar")
+include("util:datagen")
diff --git a/util/datagen/.gitignore b/util/datagen/.gitignore
new file mode 100644
index 000000000..2959db291
--- /dev/null
+++ b/util/datagen/.gitignore
@@ -0,0 +1,2 @@
+build
+logs
\ No newline at end of file
diff --git a/util/datagen/build.gradle.kts b/util/datagen/build.gradle.kts
new file mode 100644
index 000000000..6f0db8857
--- /dev/null
+++ b/util/datagen/build.gradle.kts
@@ -0,0 +1,48 @@
+plugins {
+    id("java")
+}
+
+repositories {
+    mavenCentral()
+    maven("https://libraries.minecraft.net/")
+}
+
+dependencies {
+    implementation(project(":game:core"))
+
+    implementation(libs.gson)
+    implementation(libs.jetbrains.annotations)
+}
+
+val output by configurations.creating
+
+//region Tasks
+val runDatagen by tasks.registering(JavaExec::class) {
+    group = "bta.generator"
+    val datagenDir = project.layout.buildDirectory.dir("generated/sources/datagen/resources")
+    val recipesDir = datagenDir.get().file("recipes")
+    outputs.dir(datagenDir)
+
+    mainClass.set("net.minecraft.datagen.RecipesGenerator")
+    classpath = sourceSets["main"].runtimeClasspath
+
+    args = listOf("--output", recipesDir.toString())
+}
+
+val datagenJar by tasks.registering(Jar::class) {
+    group = "bta.generator"
+    from(sourceSets["generated"].resources)
+}
+//endregion
+
+sourceSets {
+    create("generated") {
+        resources {
+            srcDir(runDatagen)
+        }
+    }
+}
+
+artifacts {
+    add("output", datagenJar)
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/datagen/RecipesGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java
similarity index 95%
rename from src/main/java/net/minecraft/datagen/RecipesGenerator.java
rename to util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java
index ed4dc625f..8d1c21f92 100644
--- a/src/main/java/net/minecraft/datagen/RecipesGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/RecipesGenerator.java
@@ -4,11 +4,11 @@ import com.google.gson.JsonArray;
 import com.google.gson.JsonElement;
 import com.google.gson.JsonParser;
 import com.google.gson.stream.JsonReader;
+import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeGroup;
 import net.minecraft.core.item.Items;
-import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 
 import java.io.File;
 import java.io.FileReader;
@@ -58,7 +58,7 @@ public class RecipesGenerator {
 
         WorkbenchGenerator.generate();
         if (DEBUG) {
-            remainingEntries = getMissingIds(Registries.RECIPES.WORKBENCH, new File("src/common/resources/recipes/workbench.json"));
+            remainingEntries = getMissingIds(Registries.RECIPES.WORKBENCH, new File("src/main/resources/recipes/workbench.json"));
             if (remainingEntries.isEmpty()) {
                 System.out.println("Workbench contains all reference entries!");
             } else {
@@ -75,7 +75,7 @@ public class RecipesGenerator {
 
         SmeltingGenerator.generate();
         if (DEBUG) {
-            remainingEntries = getMissingIds(Registries.RECIPES.FURNACE, new File("src/common/resources/recipes/furnace.json"));
+            remainingEntries = getMissingIds(Registries.RECIPES.FURNACE, new File("src/main/resources/recipes/furnace.json"));
             if (remainingEntries.isEmpty()) {
                 System.out.println("Furnace contains all reference entries!");
             } else {
@@ -91,7 +91,7 @@ public class RecipesGenerator {
         if (DEBUG) System.out.println();
 
         if (DEBUG) {
-            remainingEntries = getMissingIds(Registries.RECIPES.BLAST_FURNACE, new File("src/common/resources/recipes/blast_furnace.json"));
+            remainingEntries = getMissingIds(Registries.RECIPES.BLAST_FURNACE, new File("src/main/resources/recipes/blast_furnace.json"));
             if (remainingEntries.isEmpty()) {
                 System.out.println("Blast furnace contains all reference entries!");
             } else {
@@ -108,7 +108,7 @@ public class RecipesGenerator {
 
         TrommelGenerator.generate();
         if (DEBUG) {
-            remainingEntries = getMissingIds(Registries.RECIPES.TROMMEL, new File("src/common/resources/recipes/trommel.json"));
+            remainingEntries = getMissingIds(Registries.RECIPES.TROMMEL, new File("src/main/resources/recipes/trommel.json"));
             if (remainingEntries.isEmpty()) {
                 System.out.println("Trommel contains all reference entries!");
             } else {
diff --git a/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
similarity index 92%
rename from src/main/java/net/minecraft/datagen/SmeltingGenerator.java
rename to util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index 963195b02..ee6baeaff 100644
--- a/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -1,12 +1,10 @@
 package net.minecraft.datagen;
 
+import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
-
-import static net.minecraft.datagen.RecipesGenerator.CORE_NAMESPACE;
 
 public class SmeltingGenerator {
     public static void generate() {
@@ -49,19 +47,19 @@ public class SmeltingGenerator {
     }
 
     private static void furnaceRecipe(String id, ItemStack input, ItemStack output) {
-        RecipeBuilder.Furnace(CORE_NAMESPACE).setInput(input).create(id, output);
+        RecipeBuilder.Furnace(RecipesGenerator.CORE_NAMESPACE).setInput(input).create(id, output);
     }
 
     private static void furnaceRecipe(String id, String inputGroup, ItemStack output) {
-        RecipeBuilder.Furnace(CORE_NAMESPACE).setInput(inputGroup).create(id, output);
+        RecipeBuilder.Furnace(RecipesGenerator.CORE_NAMESPACE).setInput(inputGroup).create(id, output);
     }
 
     private static void blastRecipe(String id, ItemStack input, ItemStack output) {
-        RecipeBuilder.BlastFurnace(CORE_NAMESPACE).setInput(input).create(id, output);
+        RecipeBuilder.BlastFurnace(RecipesGenerator.CORE_NAMESPACE).setInput(input).create(id, output);
     }
 
     private static void blastRecipe(String id, String inputGroup, ItemStack output) {
-        RecipeBuilder.BlastFurnace(CORE_NAMESPACE).setInput(inputGroup).create(id, output);
+        RecipeBuilder.BlastFurnace(RecipesGenerator.CORE_NAMESPACE).setInput(inputGroup).create(id, output);
     }
 
     private static void sharedRecipe(String id, ItemStack input, ItemStack output) {
